<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product. 
 * For more information see License.txt in the plugin folder.

 * ---
 * Copyright (c) 2018, Ebenezer Obasi
 * All rights reserved.
 * info@eobasi.com.

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

 * This plugin should be bought from the developer. For details contact info@eobasi.com.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

class MPROFILE_MCLASS_EventHandler
{
    public function init()
    {
		$mobileConsoleEvent = new BASE_MCLASS_ConsoleEventHandler();
		
        OW::getEventManager()->unbind(MBOL_ConsoleService::EVENT_COLLECT_CONSOLE_PAGES, array($mobileConsoleEvent, 'addProfilePage'));
        OW::getEventManager()->bind(MBOL_ConsoleService::EVENT_COLLECT_CONSOLE_PAGES, array($this, 'addProfilePage'));
		
        OW::getEventManager()->bind(BASE_MCMP_ProfileActionToolbar::EVENT_NAME, array($this, 'addEitProfileActionTool'));
    }

    public function addEitProfileActionTool( BASE_CLASS_EventCollector $event )
    {
        if ( !OW::getUser()->isAuthenticated() )
        {
            return;
        }

        $params = $event->getParams();

        if ( empty($params['userId']) )
        {
            return;
        }

        $userId = (int) $params['userId'];

        if ( $userId != OW::getUser()->getId() )
        {
            return;
        }

        $action = array(
            "href" => OW::getRouter()->urlForRoute('base_edit'),
            "label" => OW::getLanguage()->text('base', 'edit_profile_link'),
            "class" => 'mprofile_edit_profile_link',
            "key" => "mprofile.edit_profile",
            "order" => 1
        );

        $event->add($action);
    }

    public function addProfilePage( BASE_CLASS_EventCollector $event )
    {
        $event->add(array(
            'key' => BASE_MCLASS_ConsoleEventHandler::CONSOLE_PROFILE_PAGE_KEY,
            'cmpClass' => 'MPROFILE_MCMP_ConsoleProfilePage',
            'order' => 2
        ));
    }
}